%%% this function performs location aggregation on the histograms of the
%%% GL dataset


function [hist1Agr, hist2Agr] = GLHistAggregator(hist1, hist2, locID, squareLength)


hist1 = myHistNorm(hist1);
hist2 = myHistNorm(hist2);

gridNum=39000;

% x and y grid ID of visited locations
visitedN=ceil(locID/gridNum);
visitedW=mod(locID-1,gridNum)+1;

% new x and y grid ID of visited locations 

aggN=ceil(visitedN/squareLength);
aggW=ceil(visitedW/squareLength);

aggLoc=(aggN-1)*ceil(gridNum/squareLength)+aggW;
[~,~,locMap]=unique(aggLoc);

% building aggregattion matrix
aggregateMat=sparse([1:length(locID)], locMap, 1, length(locID), max(locMap));


hist1Agr=hist1*aggregateMat;
hist2Agr=hist2*aggregateMat;
  