% This function loads the GL dataset and plots Figure 10(a) and Figure 10(b) 
% of [1].
%
% [1]: "Where you are is who you are: User identification by matching statistics",
% Farid M. Naini, Jayakrishnan Unnikrishnan, Patrick Thiran, and Martin
% Vetterli, IEEE Transactions on Information Forensics and Security, 2015
 


clear all;
close all;
clc;


% loading the histograms
load GL1;




%% plotting the activity matrix
activityMat = unique(totData(:,[1,2]),'rows');
[~,~,newUserIDs]=unique(activityMat(:,1));
activityMat(:,1)=newUserIDs;
activityMat = sparse(activityMat(:,1), activityMat(:,2), 1, max(activityMat(:,1)), max(activityMat(:,2)));
[~, ind] = sort(sum(activityMat,2), 'descend');
activityMat=activityMat(ind,:);

imagesc(activityMat);
colormap('gray');
cm=colormap;
colormap(flipud(cm));

ylabel('user ID');
xlabel('Time');

set(gca,'XTick',[1, 53, 105, 157, 209, 261])
set(gca,'XTickLabel',{2007, 2008, 2009, 2010, 2011, 2012})
title('Activity of users in the data collection campaign');


%% plotting the map
vistedLoc = unique(totData(:,3));
visitedLoc_N=ceil(vistedLoc/39000);
visitedLoc_W=mod(vistedLoc-1,39000)+1;

% reducing the resolution from 1 meter to 100 meters
visitedLoc_N = ceil(visitedLoc_N/100);
visitedLoc_W = ceil(visitedLoc_W/100);

mapGrid = zeros(390, 390);
mapGrid((390-visitedLoc_N+1)+(visitedLoc_W-1)*390)=1;
figure, imagesc(mapGrid);
colormap('gray');
cm=colormap;
colormap(flipud(cm));
xlabel('Longitute');
ylabel('Latitude');

set(gca,'XTick',[1, 195 ,390])
set(gca,'XTickLabel',{116.15, 116.375, 116.6})

set(gca,'YTick',[1, 195 ,390])
set(gca,'YTickLabel',{39.75, 39.925, 40.1})
title('Map of the Beijing area and the grid squares in which data is recorded');
