% This function computes the weight matrix  between the sets of histograms psi1
% and psi2 using the proposed metric

function weightMatProp = weightMatCalcPropMetric(psi1, psi2)


[N, K] = size(psi1);

% making sure that each row of psi1 and psi2 sums to one
psi1= myHistNorm(psi1);
psi2= myHistNorm(psi2);

% buffer
weightMatProp = zeros(N,N);


%% computing first term of the weights
for j=1:N
    %j
    histjN = (repmat(psi1(j,:),N,1) + psi2)/2;  
        
    [i1, j1, s1] = find(histjN);
    
    histjNLog = sparse(i1,j1, log(s1) , N, K, length(s1) );
        
    KLDiv_part1=histjNLog * psi1(j,:)';
    
    [~,~,s2]=find(psi1(j,:));
    KLDiv_part2= s2*log(s2');
    
        
    weightMatProp(j,:) =  weightMatProp(j,:) + KLDiv_part2-KLDiv_part1';
    
end

%% computing second term of the weights

for i=1:N
    %i
    histNi = (repmat(psi2(i,:),N,1) + psi1)/2;  
        
    [i1, j1, s1] = find(histNi);
    
    histNiLog = sparse(i1,j1, log(s1) , N, K, length(s1) );  
    
    KLDiv_part1=histNiLog * psi2(i,:)';
    
    [~,~,s2]=find(psi2(i,:));
    KLDiv_part2= s2*log(s2');
    
        
    weightMatProp(:,i) = weightMatProp(:,i) + KLDiv_part2-KLDiv_part1;
    
end
